unit KIA_ADIF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Memo2: TMemo;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  Ss:string;  //use with parseit
  T:string;
  nr:string;
  kiaDate:string;
  kiaTime:string;
  call:string;
  rstSent:string;
  rstRcvd:string;
  freq:string;
  mode:string;
  QTH:string;
  oname:string;
  other:string;
  band:string;

implementation

{$R *.DFM}

function MakeItAString(I: Longint): string;
{ Convert any integer type to a string }
var
  S: string[11];
begin
  Str(I, S);
  Result:= S;
end;

function getString(s : string) : string;
begin
  if s<>'' then
    getString := s
  else
    getString := '---';      //if a field is empty, put something in it
end;

procedure ParseIt(var contact: String);   //use with string list
var
InWord:Boolean;
Index, FirstChar:Integer;
begin
  InWord := False;
  Index := 1;
  FirstChar :=1;
  while Index <=Length(Ss) do     //ss is the string to parse
  begin
    T:=Copy(Ss,Index,1);
    If((T>='0')and (T<='9')) or     //these are the recognized characters
    ((T>='A') and (T<='Z')) or
    ((T>='a') and (T<='z')) or
    (T ='_') or
    (T ='/') or
    (T ='?') or
    (T ='.') or
    (T ='-') or
    (T =' ') or
    //(T=',') or    //can not use a comma.  It is the database delimiter
    (T =':')  then
  begin
    If not InWord then FirstChar := Index;
      InWord := true;
      end
      else begin
        If InWord then begin
           T := Copy(Ss, FirstChar, Index-FirstChar);
           Form1.ListBox1.items.add(T);
        end;
        InWord := False;
       end;
       Inc(Index);
 end;
end;


procedure TForm1.Button1Click(Sender: TObject);
Var
F:textfile;
S:string;
Fstline:string;
Sndline:string;

begin
//==================
begin
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Fstline:='';
    Sndline:='';

    While not eof(F) do
    begin

    Readln(F, S);
    Memo1.lines.add(S);


    end;

      CloseFile(F);
  end;
       end;


end;


procedure TForm1.Button2Click(Sender: TObject);
             //ADIF files
Var
ADIFString:string;
InFile : TextFile;
fname : string;

Field1,Field2,Field4,Field10,Field11,Field21:string;

begin
    Memo2.Clear;  //clear the memo
  //  dbf1.DisableControls;
 //==================
    //write header

   fname := 'kiafile'+'.adi';
        AssignFile(Infile,fname);
        try
        If fileExists('kiafile'+'.adi')then
           Append(Infile)
        else
           Rewrite(Infile);
        Writeln(Infile,'<CONTEST_ID:4>TXQSO');
        Writeln(Infile,'<EOH>');
       finally
         closeFile(Infile);
        end;
  //==================
      //  begin
         // dbf1.First;
      //    for i := 1 to strtoint(label5.caption) -1 do
         // for i := 1 to 20 do
      //    begin
      //    dbf1.Locate('Number',I,[loCaseInsensitive]);
       //     if  dbf1.FieldByName('QTH').AsString <>''then
            //=============
        //    begin
 //  Field1:= dbf1.FieldByName('DATE').AsString;
 // Field2:= dbf1.FieldByName('TIME').AsString;
 // Field3:= dbf1.FieldByName('NUMBER').AsString;
 // Field4:= dbf1.FieldByName('STATION').AsString;
 // Field5:= dbf1.FieldByName('BAND').AsString;
 // Field6:= dbf1.FieldByName('QTH').AsString;
 // Field7:= dbf1.FieldByName('RST').AsString;
 // Field8:= dbf1.FieldByName('NRSENT').AsString;
 // Field9:= dbf1.FieldByName('NRRCVD').AsString;
//  Field10:= dbf1.FieldByName('SPARE1').AsString;
 // Field11:= dbf1.FieldByName('MODE').AsString;
 // Field12:= dbf1.FieldByName('PREFIX').AsString;
 // Field13:= dbf1.FieldByName('STATE').AsString;
 // Field14:= dbf1.FieldByName('CQZONE').AsString;
 // Field15:= dbf1.FieldByName('ITUZONE').AsString;
 // Field16:= dbf1.FieldByName('TENTEN').AsString;
 // Field17:= dbf1.FieldByName('QSLS').AsString;
 // Field18:= dbf1.FieldByName('QSLR').AsString;
 // Field19:= dbf1.FieldByName('CITY').AsString;
//  Field20:= dbf1.FieldByName('REMARK').AsString;
 // Field21:= dbf1.FieldByName('FREQ').AsString;

  //to convert to ADIF date/time format
 //Field1 := FormatDateTime('yyyymmdd',strtoDate(Field1));
 //Field2 := FormatDateTime('hhmmss',strtoTime(Field2));

 // ADIFString:=(Field1+'  ,'+Field2+'  ,'+Field3+'  ,'+Field4+'  ,'+Field5+'  ,'+Field6+'  ,'+Field7+'  ,'+Field8+'  ,'+Field9+'  ');
  ADIFString:=('<CALL:'+inttostr(length(Field4))+'>'+Field4+'<NAME:'+inttostr(length(Field10))+'>'+FIELD10);
  ADIFString:=ADIFString +('<FREQ:'+inttostr(length(Field21))+'>'+Field21+'<MODE:'+inttostr(length(Field11))+'>'+FIELD11);
  ADIFString:=ADIFString +('<TIME_ON:'+inttostr(length(Field2))+'>'+Field2+'<QSO_DATE:'+inttostr(length(Field1))+'>'+Field1+'<EOR>');

  //<CALL:6>WB8SKL<NAME:6>DENNIS<FREQ:6>14.112<MODE:5>FSK31<TIME_ON:6>130947<QSO_DATE:8>20001117<EOR>
  //------------file routine

  If CheckBox1.Checked =True then
       Memo2.Lines.Add( ADIFString )
  else
 begin
        fname := 'kiafile'+'.adi';
        AssignFile(Infile,fname);
        try
        If fileExists('kiafile'+'.adi')then
           Append(Infile)
        else
           Rewrite(Infile);
           Writeln(Infile,ADIFString);

       finally
         closeFile(Infile);
        end;
  end;
  end;







procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
Var
ADIFString:string;
InFile : TextFile;
fname: string;
F:textfile;
S:string;
cntr:integer;

begin
//==================
begin
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    cntr:=0;

    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S);
    Readln(F, S);
    Memo1.lines.add(s);
    Memo2.lines.add('ADIF_VER:4>1.00<EOH>');
    While not eof(F) do
    begin
      Readln(F,Ss);
      parseit(Ss);
   //band,call,mode,date,rsts,rstr,timeon,eor required
   //for Logbook of the World
  //--------------
  //parsed logbook string to ADIF elements
  nr:= ListBox1.Items[0];
  kiaDate:=ListBox1.Items[1];
  kiaTime:=ListBox1.Items[2];
  call:=trim(ListBox1.Items[3]);
  rstSent:=trim(ListBox1.Items[4]);
  rstRcvd:=trim(ListBox1.Items[5]);
  freq:=trim(ListBox1.Items[6]);
  mode:=trim(ListBox1.Items[7]);
  QTH:=trim(ListBox1.Items[8]);
  oname:=trim(ListBox1.Items[9]);  //doesn't like 'name' in listbox
  // other:=ListBox1.Items[10];
  nr:='<STX:'+inttostr(length(nr))+'>'+nr;
  //convert date to required ADIF format
  datetimetostring(kiadate,'yyyymmdd',((strtodate(kiadate))));
  kiadate:='<QSO_DATE:'+inttostr(length(kiadate))+'>'+kiadate;
  //convert time to required ADIF format
  delete(kiatime,3,1);    //get rid of colon
  kiatime:='<TIME_ON:'+inttostr(length(kiatime))+'>'+kiatime;

  call:='<CALL:'+inttostr(length(call))+'>'+call;
  rstsent:='<RST_SENT:'+inttostr(length(rstsent))+'>'+rstsent;
  rstrcvd:='<RST_RCVD:'+inttostr(length(rstrcvd))+'>'+rstrcvd;

  //=================
  //frequency to band conversion
  if (strtofloat(freq)>1.8) and(strtofloat(freq)< 2.0) then
   band:= '160M';
  if (strtofloat(freq)>3.5) and(strtofloat(freq)< 4.0) then
   band:= '80M';
  if (strtofloat(freq)>7.0) and(strtofloat(freq)< 7.3) then
   band:= '40M';
  if(strtofloat(freq)>10.1) and(strtofloat(freq)< 10.15) then
   band:= '30M';
  if (strtofloat(freq)>14.0) and(strtofloat(freq)< 14.35) then
   band:= '20M';
  if(strtofloat(freq)>18.068) and(strtofloat(freq)< 18.168) then
   band:= '17M';
  if (strtofloat(freq)>21.0) and(strtofloat(freq)< 21.45) then
   band:= '15M';
  if(strtofloat(freq)>24.890) and (strtofloat(freq)< 24.990) then
   band:= '12M';
  if (strtofloat(freq)>28.0) and (strtofloat(freq)< 29.7) then
   band:= '10M';
  if(strtofloat(freq)>50.0) and (strtofloat(freq)< 54.0) then
   band:= '6M';
  if (strtofloat(freq)>144.0) and  (strtofloat(freq)< 148.0) then
   band:= '2M';
  //======================
  freq:='<FREQ:'+inttostr(length(freq))+'>'+freq;
  mode:='<MODE:'+inttostr(length(mode))+'>'+mode;
  qth:='<QTH:'+inttostr(length(qth))+'>'+qth;
  oname:='<NAME:'+inttostr(length(oname))+'>'+oname;
  band:='<BAND:'+inttostr(length(band))+'>'+band;
  Memo1.lines.add(Ss);
  memo2.lines.add(nr+kiadate+kiatime+call+rstsent+rstrcvd+freq+mode+qth+oname+band+'<EOR>');
  ADIFstring:=  (nr+kiadate+kiatime+call+rstsent+rstrcvd+freq+mode+qth+oname+band+'<EOR>');
 //++++++++++++++++++++
  //routine to actually write adif file
   if checkbox1.Checked = true then
     begin
        fname := OpenDialog1.FileName;
        fname := ExtractFileName(fname);

        delete(fname,(length(fname)-3),4);
        fname := fname+'.adi';
        AssignFile(Infile,fname);
        try
        If fileExists(fname)then

           Append(Infile)

        else
           Rewrite(Infile);

         if cntr=0 then
             begin
             Writeln(Infile,'ADIF_VER:4>1.00<EOH>');
             cntr:=1;
             end
             else

           cntr:=1;
           Writeln(Infile,ADIFString);

       finally
         closeFile(Infile);
        end;
  end;

//+++++++++++++++++++
   ListBox1.Clear;
   Ss:='';

  end;
  //-------------------
  end;
 end;
      CloseFile(F);
end;


end.
